'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('immutable'),
    List = _require.List;

var SET_IN = 'SET_IN';
var PUSH_IN = 'PUSH_IN';
var DELETE_IN = 'DELETE_IN';
var NEW_NAMED_NODE = 'NEW_NAMED_NODE';
var UPDATE_EDITPATH = 'UPDATE_EDITPATH';
var UPDATE_SHOWPATH = 'UPDATE_SHOWPATH';
var UPDATE_INPUT = 'UPDATE_INPUT';
var UPDATE_SUGGESTIONS = 'UPDATE_SUGGESTIONS';
var UPDATE_UNIVERSE = 'UPDATE_UNIVERSE';
var UPDATE_MINT_ID = 'UPDATE_MINT_ID';
var UPDATE_ON_NEW_NAMED_NODE = 'UPDATE_ON_NEW_NAMED_NODE';
var TOGGLE_EDITING_PROPERTIES = 'TOGGLE_EDITING_PROPERTIES';

exports.SET_IN = SET_IN;
exports.PUSH_IN = PUSH_IN;
exports.DELETE_IN = DELETE_IN;
exports.NEW_NAMED_NODE = NEW_NAMED_NODE;
exports.UPDATE_EDITPATH = UPDATE_EDITPATH;
exports.UPDATE_SHOWPATH = UPDATE_SHOWPATH;
exports.UPDATE_INPUT = UPDATE_INPUT;
exports.UPDATE_SUGGESTIONS = UPDATE_SUGGESTIONS;
exports.UPDATE_UNIVERSE = UPDATE_UNIVERSE;
exports.UPDATE_MINT_ID = UPDATE_MINT_ID;
exports.UPDATE_ON_NEW_NAMED_NODE = UPDATE_ON_NEW_NAMED_NODE;
exports.TOGGLE_EDITING_PROPERTIES = TOGGLE_EDITING_PROPERTIES;

var setIn = function setIn(path, value) {
  var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      input = _ref.input,
      editPath = _ref.editPath;

  return { type: SET_IN,
    path: path,
    value: value,
    input: input,
    editPath: editPath
  };
};
exports.setIn = setIn;

exports.updateNode = function (node) {
  return setIn(List(), node);
};

exports.pushIn = function (path, value) {
  var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      editPath = _ref2.editPath;

  return { type: PUSH_IN,
    path: path,
    value: value,
    editPath: editPath
  };
};

exports.deleteIn = function (path) {
  return { type: DELETE_IN,
    path: path
  };
};

exports.newNamedNode = function (node) {
  return { type: NEW_NAMED_NODE,
    node: node
  };
};

exports.updateEditPath = function (path, input) {
  return { type: UPDATE_EDITPATH,
    path: path,
    input: input
  };
};

exports.updateRootNodePath = function (path) {
  return { type: UPDATE_SHOWPATH,
    path: path
  };
};

exports.updateInput = function (input) {
  return { type: UPDATE_INPUT,
    input: input
  };
};

exports.updateSuggestions = function (suggestions) {
  return { type: UPDATE_SUGGESTIONS,
    suggestions: suggestions
  };
};

exports.updateUniverse = function (domains) {
  return (0, _extends3.default)({ type: UPDATE_UNIVERSE
  }, domains);
};

exports.updateMintID = function (mintID) {
  return { type: UPDATE_MINT_ID,
    mintID: mintID
  };
};

exports.updateOnNewNamedNode = function (onNewNamedNode) {
  return { type: UPDATE_ON_NEW_NAMED_NODE,
    onNewNamedNode: onNewNamedNode
  };
};

exports.toggleEditingProperties = function () {
  return { type: TOGGLE_EDITING_PROPERTIES
  };
};