'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react') // eslint-disable-line no-unused-vars
,
    RebassAutosuggest = require('rebass-autosuggest');

var Autosuggest = function Autosuggest(_ref) {
  var input = _ref.input,
      label = _ref.label,
      focused = _ref.focused,
      onFocus = _ref.onFocus,
      onBlur = _ref.onBlur,
      updateInput = _ref.updateInput,
      props = (0, _objectWithoutProperties3.default)(_ref, ['input', 'label', 'focused', 'onFocus', 'onBlur', 'updateInput']);


  return React.createElement(RebassAutosuggest, (0, _extends3.default)({
    label: label,
    getSuggestionValue: function getSuggestionValue(suggestion) {
      return suggestion.label;
    },
    renderSuggestion: function renderSuggestion(suggestion) {
      return suggestion.label;
    },
    inputProps: { value: input,
      placeholder: label,
      onFocus: onFocus,
      onBlur: onBlur,
      onChange: function onChange(e, _ref2) {
        var newValue = _ref2.newValue,
            method = _ref2.method;

        if (method === 'type') {
          updateInput(newValue);
        }
      }
    },
    baseRef: function baseRef(input) {
      if (input && focused) {
        input.focus();
      }
    }
  }, props));
};

module.exports = Autosuggest;