'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    classnames = require('classnames'),
    _require = require('rebass'),
    withRebass = _require.withRebass,
    RemoveButton = require('./RemoveButton'); // eslint-disable-line no-unused-vars


var Chip = function Chip(_ref) {
  var children = _ref.children,
      onClick = _ref.onClick,
      onClickDelete = _ref.onClickDelete,
      className = _ref.className,
      style = _ref.style,
      theme = _ref.theme,
      subComponentStyles = _ref.subComponentStyles,
      props = (0, _objectWithoutProperties3.default)(_ref, ['children', 'onClick', 'onClickDelete', 'className', 'style', 'theme', 'subComponentStyles']);
  var fontSizes = theme.fontSizes,
      scale = theme.scale,
      colors = theme.colors;


  var cx = classnames('Chip', className);

  var rootStyle = (0, _objectWithoutProperties3.default)(style, []);


  var sx = { root: (0, _extends3.default)({ display: 'inline-flex',
      alignItems: 'center',
      justifyContent: 'center',
      height: scale[3],
      lineHeight: scale[3],
      borderRadius: 99999,
      color: colors.default,
      backgroundColor: colors.muted,
      cursor: onClick ? 'pointer' : 'default'
    }, rootStyle),
    inner: (0, _extends3.default)({ pointerEvents: 'none',
      marginLeft: fontSizes[6],
      marginRight: onClickDelete ? 0 : fontSizes[6]
    }, subComponentStyles.inner),
    remove: (0, _extends3.default)({ margin: '0 ' + fontSizes[2] / 6 + 'px'
    }, subComponentStyles.remove)
  };

  return React.createElement(
    'div',
    (0, _extends3.default)({
      className: cx,
      style: sx.root,
      onClick: onClick
    }, props),
    React.createElement(
      'div',
      { style: sx.inner },
      children
    ),
    onClickDelete ? React.createElement(RemoveButton, {
      color: style.backgroundColor === colors.black ? 'rgba(255, 255, 255, 0.54)' : 'rgba(0, 0, 0, 0.54)',
      style: sx.remove,
      onClick: function onClick(e) {
        e.stopPropagation();
        onClickDelete();
      }
    }) : null
  );
};

Chip.propTypes = {
  onClick: React.PropTypes.func,
  onClickDelete: React.PropTypes.func
};

Chip._name = 'Chip';

module.exports = withRebass(Chip);