'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    classnames = require('classnames'),
    _require = require('rebass'),
    withRebass = _require.withRebass,
    Dropdown = _require.Dropdown,
    DropdownMenu = _require.DropdownMenu; // eslint-disable-line no-unused-vars


var Modal = function Modal(_ref) {
  var children = _ref.children,
      className = _ref.className,
      style = _ref.style,
      theme = _ref.theme,
      props = (0, _objectWithoutProperties3.default)(_ref, ['children', 'className', 'style', 'theme']);
  var colors = theme.colors;


  var cx = classnames('Modal', className);

  var _React$Children$toArr = React.Children.toArray(children),
      _React$Children$toArr2 = (0, _toArray3.default)(_React$Children$toArr),
      first = _React$Children$toArr2[0],
      rest = _React$Children$toArr2.slice(1);

  var sx = (0, _extends3.default)({ borderColor: colors.muted,
    left: 10,
    width: 224,
    Menu: { overflow: 'visible' }
  }, style);

  return React.createElement(
    Dropdown,
    { className: cx },
    first,
    React.createElement(
      DropdownMenu,
      (0, _extends3.default)({
        open: true,
        style: sx
      }, props),
      rest
    )
  );
};

Modal._name = 'Modal';

module.exports = withRebass(Modal);