'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    classnames = require('classnames'),
    _require = require('rebass'),
    withRebass = _require.withRebass,
    Cancel = require('react-icons/lib/md/cancel'); // eslint-disable-line no-unused-vars


var RemoveButton = function RemoveButton(_ref) {
  var className = _ref.className,
      style = _ref.style,
      theme = _ref.theme,
      subComponentStyles = _ref.subComponentStyles,
      props = (0, _objectWithoutProperties3.default)(_ref, ['className', 'style', 'theme', 'subComponentStyles']);
  var fontSizes = theme.fontSizes;


  var cx = classnames('RemoveButton', className);

  var color = style.color,
      rootStyle = (0, _objectWithoutProperties3.default)(style, ['color']);


  var sx = { root: (0, _extends3.default)({ height: fontSizes[2] + 'px',
      width: fontSizes[2] + 'px',
      position: 'relative'
    }, rootStyle),
    icon: (0, _extends3.default)({ cursor: 'pointer',
      position: 'absolute'
    }, subComponentStyles.icon)
  };

  return React.createElement(
    'div',
    (0, _extends3.default)({
      className: cx,
      style: sx.root
    }, props),
    React.createElement(Cancel, {
      size: fontSizes[2],
      color: color,
      style: sx.icon
    })
  );
};

RemoveButton._name = 'RemoveButton';

module.exports = withRebass(RemoveButton);