'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    _require = require('react-redux'),
    connect = _require.connect,
    _require2 = require('redux'),
    bindActionCreators = _require2.bindActionCreators,
    _require3 = require('../selectors'),
    getInput = _require3.getInput,
    getEditPath = _require3.getEditPath,
    getSuggestions = _require3.getSuggestions,
    getIndividualSuggester = _require3.getIndividualSuggester,
    getIndividuals = _require3.getIndividuals,
    getPredicateRangeFinder = _require3.getPredicateRangeFinder,
    getIDMinter = _require3.getIDMinter,
    _require4 = require('../actions'),
    updateEditPath = _require4.updateEditPath,
    updateInput = _require4.updateInput,
    updateSuggestions = _require4.updateSuggestions,
    setIn = _require4.setIn,
    newNamedNode = _require4.newNamedNode,
    Autosuggest = require('../components/Autosuggest'),
    _require5 = require('../utils'),
    node = _require5.node,
    _require6 = require('../namespaces'),
    rdfs = _require6.rdfs; // eslint-disable-line no-unused-vars


var mapStateToProps = function mapStateToProps(state) {
  return { input: getInput(state),
    suggestions: getSuggestions(state),
    findSuggestions: getIndividualSuggester(state),
    editPath: getEditPath(state),
    individuals: getIndividuals(state),
    getPredicateRange: getPredicateRangeFinder(state),
    mintID: getIDMinter(state)
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return bindActionCreators({ updateEditPath: updateEditPath,
    updateInput: updateInput,
    updateSuggestions: updateSuggestions,
    setIn: setIn,
    newNamedNode: newNamedNode
  }, dispatch);
};

var mergeProps = function mergeProps(_ref, _ref2, _ref3) {
  var input = _ref.input,
      suggestions = _ref.suggestions,
      findSuggestions = _ref.findSuggestions,
      editPath = _ref.editPath,
      individuals = _ref.individuals,
      getPredicateRange = _ref.getPredicateRange,
      mintID = _ref.mintID;
  var updateEditPath = _ref2.updateEditPath,
      updateInput = _ref2.updateInput,
      updateSuggestions = _ref2.updateSuggestions,
      setIn = _ref2.setIn,
      newNamedNode = _ref2.newNamedNode;
  var path = _ref3.path,
      props = (0, _objectWithoutProperties3.default)(_ref3, ['path']);
  return (0, _extends3.default)({ name: 'new_node',
    label: 'New value',
    mb: 0,
    hideLabel: true,
    input: editPath.equals(path) ? input : '',
    suggestions: suggestions,
    onFocus: function onFocus() {
      return updateEditPath(path);
    },
    onBlur: function onBlur() {
      return updateEditPath(path.pop().pop());
    },
    onSuggestionsFetchRequested: function onSuggestionsFetchRequested(_ref4) {
      var value = _ref4.value;

      updateSuggestions([{ label: 'Create \u201C' + value + '\u201D', value: value }].concat((0, _toConsumableArray3.default)(findSuggestions(value))));
    },
    onSuggestionsClearRequested: function onSuggestionsClearRequested() {
      return updateSuggestions([]);
    },
    onSuggestionSelected: function onSuggestionSelected(_, _ref5) {
      var suggestion = _ref5.suggestion;

      var individual = individuals.get(suggestion.id);
      if (!individual) {
        var types = getPredicateRange(path.butLast().last());
        if (types.some(mintID.accepts) || mintID.accepts(rdfs('Resource'))) {
          // named node
          individual = node(mintID(types.toArray()), suggestion.value, types);
          newNamedNode(individual);
        } else {
          // blank node
          individual = node(undefined, suggestion.value, types);
        }
      }
      setIn(path, individual, { editPath: path.set(-1, path.last() + 1) });
    },
    focused: editPath.equals(path),
    updateInput: updateInput
  }, props);
};

var AddNode = connect(mapStateToProps, mapDispatchToProps, mergeProps)(Autosuggest);

AddNode.displayName = 'AddNode';

module.exports = AddNode;