'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    _require = require('react-redux'),
    connect = _require.connect,
    _require2 = require('redux'),
    bindActionCreators = _require2.bindActionCreators,
    _require3 = require('rebass'),
    Input = _require3.Input,
    _require4 = require('immutable-jsonld'),
    JSONLDValue = _require4.JSONLDValue,
    _require5 = require('../selectors'),
    getInput = _require5.getInput,
    getEditPath = _require5.getEditPath,
    getPredicateRangeFinder = _require5.getPredicateRangeFinder,
    _require6 = require('../actions'),
    updateEditPath = _require6.updateEditPath,
    updateInput = _require6.updateInput,
    setIn = _require6.setIn; // eslint-disable-line no-unused-vars


var mapStateToProps = function mapStateToProps(state) {
  return { input: getInput(state),
    editPath: getEditPath(state),
    getPredicateRange: getPredicateRangeFinder(state)
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return bindActionCreators({ updateEditPath: updateEditPath, updateInput: updateInput, setIn: setIn }, dispatch);
};

var mergeProps = function mergeProps(_ref, _ref2, _ref3) {
  var input = _ref.input,
      editPath = _ref.editPath,
      getPredicateRange = _ref.getPredicateRange;
  var updateEditPath = _ref2.updateEditPath,
      updateInput = _ref2.updateInput,
      setIn = _ref2.setIn;
  var path = _ref3.path,
      props = (0, _objectWithoutProperties3.default)(_ref3, ['path']);

  return (0, _extends3.default)({ label: 'New value',
    placeholder: 'New value',
    name: path.join('|'),
    value: editPath.equals(path) ? input : '',
    mb: 0,
    hideLabel: true,
    onFocus: function onFocus() {
      return updateEditPath(path);
    },
    onChange: function onChange(e) {
      return updateInput(e.target.value);
    },
    onKeyDown: function onKeyDown(e) {
      if (e.key === 'Enter') {
        var value = JSONLDValue().set('@value', e.target.value);
        var type = getPredicateRange(path.butLast().last()).first();
        setIn(path, type ? value.set('@type', type) : value, { editPath: path.set(-1, path.last() + 1) });
      }
    },
    baseRef: function baseRef(input) {
      if (input && editPath.equals(path)) {
        input.focus();
      }
    }
  }, props);
};

var AddValue = connect(mapStateToProps, mapDispatchToProps, mergeProps)(Input);

AddValue.displayName = 'AddValue';

module.exports = AddValue;