'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    _require = require('react-redux'),
    connect = _require.connect,
    _require2 = require('redux'),
    bindActionCreators = _require2.bindActionCreators,
    Chip = require('../components/Chip'),
    _require3 = require('../actions'),
    deleteIn = _require3.deleteIn,
    _require4 = require('../selectors'),
    getNode = _require4.getNode,
    getLabelResolver = _require4.getLabelResolver; // eslint-disable-line no-unused-vars


var mapStateToProps = function mapStateToProps(state, _ref) {
  var path = _ref.path;
  return { label: getLabelResolver(state)(getNode(state).getIn(path)) };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return bindActionCreators({ deleteIn: deleteIn }, dispatch);
};

var mergeProps = function mergeProps(_ref2, _ref3, _ref4) {
  var label = _ref2.label;
  var deleteIn = _ref3.deleteIn;
  var path = _ref4.path,
      props = (0, _objectWithoutProperties3.default)(_ref4, ['path']);
  return (0, _extends3.default)({ children: label,
    onClickDelete: function onClickDelete() {
      return deleteIn(path);
    }
  }, props);
};

var ShowIdentifier = connect(mapStateToProps, mapDispatchToProps, mergeProps)(Chip);

ShowIdentifier.displayName = 'ShowIdentifier';

module.exports = ShowIdentifier;