'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    _require = require('react-redux'),
    connect = _require.connect,
    _require2 = require('redux'),
    bindActionCreators = _require2.bindActionCreators,
    _require3 = require('rebass'),
    Space = _require3.Space,
    _require4 = require('../actions'),
    updateRootNodePath = _require4.updateRootNodePath,
    deleteIn = _require4.deleteIn,
    Chip = require('../components/Chip'),
    _require5 = require('../selectors'),
    getNode = _require5.getNode,
    _require6 = require('../utils'),
    labelOrID = _require6.labelOrID; // eslint-disable-line no-unused-vars


var mapStateToProps = function mapStateToProps(state, _ref) {
  var path = _ref.path;
  return { children: [labelOrID(getNode(state).getIn(path)) || React.createElement(Space, { x: 3 })]
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return bindActionCreators({ updateRootNodePath: updateRootNodePath, deleteIn: deleteIn }, dispatch);
};

var mergeProps = function mergeProps(_ref2, _ref3, _ref4) {
  var children = _ref2.children;
  var updateRootNodePath = _ref3.updateRootNodePath,
      deleteIn = _ref3.deleteIn;
  var path = _ref4.path,
      _ref4$deletable = _ref4.deletable,
      deletable = _ref4$deletable === undefined ? true : _ref4$deletable,
      props = (0, _objectWithoutProperties3.default)(_ref4, ['path', 'deletable']);
  return (0, _extends3.default)({ children: children,
    color: 'white',
    backgroundColor: 'black',
    onClick: function onClick() {
      return updateRootNodePath(path);
    },
    onClickDelete: deletable ? function () {
      return deleteIn(path);
    } : null
  }, props);
};

var ShowNode = connect(mapStateToProps, mapDispatchToProps, mergeProps)(Chip);

ShowNode.displayName = 'ShowNode';

module.exports = ShowNode;