'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    _require = require('react-redux'),
    connect = _require.connect,
    _require2 = require('redux'),
    bindActionCreators = _require2.bindActionCreators,
    _require3 = require('immutable'),
    Set = _require3.Set,
    _require4 = require('../actions'),
    deleteIn = _require4.deleteIn,
    updateEditPath = _require4.updateEditPath,
    _require5 = require('../selectors'),
    getNode = _require5.getNode,
    Chip = require('../components/Chip'),
    _require6 = require('../namespaces'),
    xsd = _require6.xsd; // eslint-disable-line no-unused-vars


var NON_TEXT_TYPES = Set.of(xsd('dateTime'), xsd('decimal'), xsd('float'), xsd('gYear'), xsd('integer'));
var notText = function notText(type) {
  return NON_TEXT_TYPES.includes(type);
};

var show = function show(value) {
  switch ((0, _typeof3.default)(value.value)) {
    case 'string':
      return notText(value.type) ? '' + value.value : '\u201C' + value.value + '\u201D';
    default:
      return '' + value.value;
  }
};

var mapStateToProps = function mapStateToProps(state, _ref) {
  var path = _ref.path;
  return { value: getNode(state).getIn(path) };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return bindActionCreators({ updateEditPath: updateEditPath, deleteIn: deleteIn }, dispatch);
};

var mergeProps = function mergeProps(_ref2, _ref3, _ref4) {
  var value = _ref2.value;
  var updateEditPath = _ref3.updateEditPath,
      deleteIn = _ref3.deleteIn;
  var path = _ref4.path,
      _ref4$deletable = _ref4.deletable,
      deletable = _ref4$deletable === undefined ? true : _ref4$deletable,
      props = (0, _objectWithoutProperties3.default)(_ref4, ['path', 'deletable']);
  return (0, _extends3.default)({ children: show(value),
    onClick: function onClick() {
      return updateEditPath(path);
    },
    onClickDelete: deletable ? function () {
      return deleteIn(path);
    } : null
  }, props);
};

var ShowValue = connect(mapStateToProps, mapDispatchToProps, mergeProps)(Chip);

ShowValue.displayName = 'ShowValue';

module.exports = ShowValue;