'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    _require = require('react-redux'),
    connect = _require.connect,
    _require2 = require('immutable'),
    List = _require2.List,
    Set = _require2.Set,
    _require3 = require('rebass'),
    Text = _require3.Text,
    Space = _require3.Space,
    _require4 = require('../selectors'),
    getNode = _require4.getNode,
    getClasses = _require4.getClasses,
    getIDMinter = _require4.getIDMinter,
    _require5 = require('../utils'),
    keyFromPath = _require5.keyFromPath,
    ignoreDispatch = _require5.ignoreDispatch,
    keepOnlyStateProps = _require5.keepOnlyStateProps,
    FlexRow = require('../components/FlexRow'),
    ShowIdentifier = require('./ShowIdentifier'),
    AddTypeIdentifier = require('./AddTypeIdentifier'),
    _require6 = require('../namespaces'),
    rdfs = _require6.rdfs; // eslint-disable-line no-unused-vars


var mapStateToProps = function mapStateToProps(state, _ref) {
  var path = _ref.path;

  var ids = getNode(state).getIn(path, List());
  var canAddTypeIdentifier = getIDMinter(state).accepts(rdfs('Class')) || !Set(getClasses(state).keySeq()).subtract(ids).isEmpty();
  return { children: [React.createElement(
      Text,
      null,
      'is a'
    ), ids.isEmpty() ? null : ids.map(function (o, i) {
      return React.createElement(ShowIdentifier, keyFromPath(path.push(i)));
    }), canAddTypeIdentifier ? React.createElement(AddTypeIdentifier, (0, _extends3.default)({}, keyFromPath(path.push(ids.count())), {
      exclude: ids
    })) : React.createElement(Space, null)]
  };
};

var Type = connect(mapStateToProps, ignoreDispatch, keepOnlyStateProps)(FlexRow);

Type.displayName = 'Type';

module.exports = Type;