'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'),
    _require = require('react-redux'),
    connect = _require.connect,
    _require2 = require('../selectors'),
    getEditPath = _require2.getEditPath,
    EditValue = require('./EditValue'),
    ShowValue = require('./ShowValue'),
    _require3 = require('../utils'),
    ignoreDispatch = _require3.ignoreDispatch; // eslint-disable-line no-unused-vars


var startsWith = function startsWith(pathA, pathB) {
  return pathA.slice(0, pathB.count()).equals(pathB);
};

var mapStateToProps = function mapStateToProps(state, _ref) {
  var path = _ref.path;
  return { path: path,
    editable: startsWith(getEditPath(state), path)
  };
};

var Value = function Value(_ref2) {
  var path = _ref2.path,
      editable = _ref2.editable,
      props = (0, _objectWithoutProperties3.default)(_ref2, ['path', 'editable']);
  return editable ? React.createElement(EditValue, (0, _extends3.default)({ path: path }, props)) : React.createElement(ShowValue, (0, _extends3.default)({ path: path }, props));
};

module.exports = connect(mapStateToProps, ignoreDispatch)(Value);