'use strict';

var _require = require('immutable'),
    Map = _require.Map,
    _require2 = require('../actions'),
    UPDATE_UNIVERSE = _require2.UPDATE_UNIVERSE,
    NEW_NAMED_NODE = _require2.NEW_NAMED_NODE,
    _require3 = require('../namespaces'),
    rdfs = _require3.rdfs;

module.exports = function () {
  var classes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Map();
  var action = arguments[1];

  switch (action.type) {
    case UPDATE_UNIVERSE:
      return action.classes || classes;

    case NEW_NAMED_NODE:
      return action.node && action.node.types.includes(rdfs('Class')) ? classes.set(action.node.id, action.node) : classes;

    default:
      return classes;
  }
};