'use strict';

var _require = require('immutable'),
    Map = _require.Map,
    List = _require.List,
    _require2 = require('redux'),
    combineReducers = _require2.combineReducers,
    _require3 = require('../actions'),
    UPDATE_UNIVERSE = _require3.UPDATE_UNIVERSE,
    SET_IN = _require3.SET_IN,
    UPDATE_EDITPATH = _require3.UPDATE_EDITPATH,
    UPDATE_SHOWPATH = _require3.UPDATE_SHOWPATH,
    UPDATE_INPUT = _require3.UPDATE_INPUT,
    UPDATE_SUGGESTIONS = _require3.UPDATE_SUGGESTIONS,
    TOGGLE_EDITING_PROPERTIES = _require3.TOGGLE_EDITING_PROPERTIES;

var datatypes = function datatypes() {
  var datatypes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Map();
  var action = arguments[1];

  switch (action.type) {
    case UPDATE_UNIVERSE:
      return action.datatypes || datatypes;

    default:
      return datatypes;
  }
};

var languages = function languages() {
  var languages = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Map();
  var action = arguments[1];

  switch (action.type) {
    case UPDATE_UNIVERSE:
      return action.languages || languages;

    default:
      return languages;
  }
};

var rootNodePath = function rootNodePath() {
  var rootNodePath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : List();
  var action = arguments[1];

  switch (action.type) {

    case UPDATE_SHOWPATH:
      return action.path;

    default:
      return rootNodePath;
  }
};

var input = function input() {
  var input = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var action = arguments[1];

  switch (action.type) {

    case UPDATE_INPUT:
    case UPDATE_EDITPATH:
    case SET_IN:
      return action.input || '';

    default:
      return input;
  }
};

var suggestions = function suggestions() {
  var suggestions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var action = arguments[1];

  switch (action.type) {

    case UPDATE_SUGGESTIONS:
      return action.suggestions;

    default:
      return suggestions;
  }
};

var isEditingProperties = function isEditingProperties() {
  var isEditingProperties = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var action = arguments[1];

  switch (action.type) {

    case TOGGLE_EDITING_PROPERTIES:
      return !isEditingProperties;

    default:
      return isEditingProperties;
  }
};

module.exports = combineReducers({ node: require('./node'),
  datatypes: datatypes,
  languages: languages,
  editPath: require('./editPath'),
  rootNodePath: rootNodePath,
  input: input,
  suggestions: suggestions,
  isEditingProperties: isEditingProperties,
  individuals: require('./individuals'),
  classes: require('./classes'),
  properties: require('./properties'),
  mintID: require('./mintID'),
  onNewNamedNode: require('./onNewNamedNode')
});