'use strict';

var _require = require('immutable'),
    Set = _require.Set,
    Map = _require.Map,
    _require2 = require('../actions'),
    UPDATE_UNIVERSE = _require2.UPDATE_UNIVERSE,
    NEW_NAMED_NODE = _require2.NEW_NAMED_NODE,
    _require3 = require('../namespaces'),
    rdf = _require3.rdf,
    rdfs = _require3.rdfs,
    owl = _require3.owl;

var nonIndividualTypes = Set.of(owl('AnnotationProperty'), owl('Class'), owl('DatatypeProperty'), owl('ObjectProperty'), owl('Ontology'), owl('OntologyProperty'), rdf('Property'), rdfs('Class'), rdfs('Datatype'), rdfs('Literal'));

var isIndividual = function isIndividual(node) {
  return node.types.intersect(nonIndividualTypes).isEmpty();
};

module.exports = function () {
  var individuals = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Map();
  var action = arguments[1];

  switch (action.type) {
    case UPDATE_UNIVERSE:
      return action.individuals || individuals;

    case NEW_NAMED_NODE:
      return action.node && action.node.id && isIndividual(action.node) ? individuals.set(action.node.id, action.node) : individuals;

    default:
      return individuals;
  }
};