'use strict';

var _require = require('../actions'),
    UPDATE_MINT_ID = _require.UPDATE_MINT_ID;

var noop = function noop() {
  return undefined;
};
var acceptsNone = function acceptsNone() {
  return false;
};
var acceptsAny = function acceptsAny() {
  return true;
};

noop.accepts = acceptsNone;

module.exports = function () {
  var mintID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;
  var action = arguments[1];

  var nextMintID = mintID;
  switch (action.type) {

    case UPDATE_MINT_ID:
      nextMintID = action.mintID || mintID;
      break;
  }
  if (!nextMintID.accepts) {
    nextMintID.accepts = acceptsAny;
  }
  return nextMintID;
};