'use strict';

var _require = require('immutable-jsonld'),
    JSONLDNode = _require.JSONLDNode,
    _require2 = require('../actions'),
    SET_IN = _require2.SET_IN,
    PUSH_IN = _require2.PUSH_IN,
    DELETE_IN = _require2.DELETE_IN;

module.exports = function () {
  var node = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : JSONLDNode();
  var action = arguments[1];

  switch (action.type) {

    case DELETE_IN:
      return node.deleteIn(action.path);

    case SET_IN:
      return node.setIn(action.path, action.value);

    case PUSH_IN:
      return node.updateIn(action.path.butLast(), function (node) {
        return node.push(action.path.last(), action.value);
      });

    default:
      return node;
  }
};