'use strict';

var _require = require('immutable'),
    Map = _require.Map,
    List = _require.List,
    Set = _require.Set,
    _require2 = require('../utils'),
    node = _require2.node,
    _require3 = require('../actions'),
    UPDATE_UNIVERSE = _require3.UPDATE_UNIVERSE,
    NEW_NAMED_NODE = _require3.NEW_NAMED_NODE,
    _require4 = require('../namespaces'),
    rdfs = _require4.rdfs,
    owl = _require4.owl;

var label = node(rdfs('label'), 'label', List.of(owl('AnnotationProperty')));

var propertyTypes = Set.of(owl('DatatypeProperty'), owl('ObjectProperty'));

var isProperty = function isProperty(node) {
  return !node.types.intersect(propertyTypes).isEmpty();
};

module.exports = function () {
  var properties = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Map();
  var action = arguments[1];

  var nextProperties = properties;
  switch (action.type) {

    case UPDATE_UNIVERSE:
      nextProperties = action.properties || properties;
      break;

    case NEW_NAMED_NODE:
      nextProperties = action.node && isProperty(action.node) ? properties.set(action.node.id, action.node) : properties;
      break;
  }
  return nextProperties.has(label.id) ? nextProperties : nextProperties.set(label.id, label);
};