'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('immutable'),
    List = _require.List,
    _require2 = require('immutable-jsonld'),
    JSONLDValue = _require2.JSONLDValue,
    JSONLDNode = _require2.JSONLDNode,
    _require3 = require('./namespaces'),
    rdfs = _require3.rdfs;

var isScrolledIntoView = function isScrolledIntoView(el) {
  return el.getBoundingClientRect().top >= 0 && el.getBoundingClientRect().bottom <= window.innerHeight;
};

var value = function value(v) {
  return JSONLDValue({ '@value': v });
};

module.exports = {

  show: function show(x) {
    return console.log((0, _stringify2.default)(x.toJS(), null, '  '));
  },

  isScrolledIntoView: isScrolledIntoView,

  positionInputCaret: function positionInputCaret(pos, focus) {
    return function (input) {
      if (input !== null) {
        input.setSelectionRange(pos, pos);
        if (focus && isScrolledIntoView(input)) {
          input.focus();
        }
      }
    };
  },

  keyFromPath: function keyFromPath(path) {
    return { path: path, key: path.join('|') };
  },

  labelOrID: function labelOrID(node) {
    var label = node.preferredLabel();
    return label ? label.value : node.id || '';
  },

  ignoreDispatch: function ignoreDispatch() {
    return {};
  },

  keepOnlyStateProps: function keepOnlyStateProps(p) {
    return p;
  },

  value: value,

  node: function node(id, label, types) {
    var n = JSONLDNode();
    if (id) {
      n = n.set('@id', id);
    }
    if (label) {
      n = n.set(rdfs('label'), List.of(value(label)));
    }
    if (types) {
      n = n.set('@type', List(types));
    }
    return n;
  }
};